; diseq analyser/positioner 
; version 1.0
; ASM51

$MOD51

IRINPUT    bit P3.2
DSQINPUT   bit P3.3
BTNUp      bit P3.4
DSQOUT     bit P3.5
LED22      bit P3.7
DISPClock  bit P1.0
DISPReset  bit P1.1
SW13_18    bit P1.2
DSQPower   bit P1.3
BTNDwn     bit P1.4
SDA        bit P1.5
PosMotorOn bit P1.6
SCL        bit P1.7

rbcnt      equ 12
cmdlength  equ 11
xth0       equ 0DCh
xth0neg    equ 0FFh-0DCh
xtl0       equ 32h
maxmotpos  equ 32
tmrposmax  equ 200         ; ~ 1s 
tmrcommax  equ 100         ; ~ 500ms 
irdatacnt  equ 8
irbdown    equ 11
irbup      equ 10
ieenable   equ 10010111b
iedisable  equ 10010000b
ptimeout   equ 110         ; 110s at 13V

bseg at 20h

dsqsilence: dbit 1
irsilence:  dbit 1
irdetect:   dbit 1
Enable22:   dbit 1
COMavail:   dbit 1
PosChanged: dbit 1
IRnumber:   dbit 1
still22:    dbit 1
analyse:    dbit 1
powerstat:  dbit 1


dseg at 30h

tmrcom:  ds 1
chars:   ds 1
tmrpos:  ds 1
motpos:  ds 1

DSQTIME: ds 1
DSQBIT:  ds 1
DSQCNT:  ds 1
DSQBUF:  ds 15

v1:      ds 1
v2:      ds 1
v3:      ds 1
v4:      ds 1
rptr:    ds 1
rdata:   ds rbcnt

irdlen:  ds 1
irdrep:  ds 1
irrecv:  ds 1
irbit:   ds 1
irtimer: ds 1
irvalue: ds 1
irptr:   ds 1
irdata:  ds irdatacnt
xtimer:  ds 1
ptimer:  ds 1



cmp MACRO source,oper
    mov a,source
    clr c
    subb a,oper 
endm


cseg
    org 0000h
    jmp start
    org 0003h
    jmp IInt0
    org 000Bh
    jmp ITimer0
    org 0013h
    jmp IInt1
    org 001Bh
    jmp ITimer1
    org 0023h
    jmp uart

ITimer0:       
    clr TR0
    mov TL0,#xtl0
    mov TH0,#xth0
    setb TR0
    push psw
    push acc

    setb led22

;    jb analyse,itimer09

    mov a,xtimer
    clr c
    subb a,#6
    jc itimer08
    setb irsilence
    jb irdetect,itimer09
    call IRReceived
    jmp itimer09
itimer08:
    inc xtimer
itimer09:


    setb dsqsilence
    call DSQReceived


itimer00:     
    mov a,tmrpos
    jz itimer01
    dec tmrpos
itimer01:
    mov a,tmrcom
    jz itimer02
    dec tmrcom
itimer02:
    pop acc
    pop psw
    reti

ITimer1:
    reti


IInt0:
    jnb analyse,iint0c
    reti
iint0c:
    push psw
    push acc
    mov a,TH0
    clr TR0
    mov TL0,#xtl0           
    mov TH0,#xth0
    setb TR0

    clr c
    subb a,#xth0
    mov irtimer,a

    mov a,#xth0neg
    mov b,xtimer
    mul ab
    add a,irtimer
    mov irtimer,a
    mov xtimer,#0

    jnb irsilence,iint00
    clr irsilence
;    call IRReceived
    mov irtimer,#0ffh
iint00:
    jnb irdetect,iint04
    mov a,irtimer
    call sendchar
iint04:
    mov a,#irdata
    add a,irptr
    mov r0,a
    cmp irptr,#irdatacnt
    jnc iint01
    cmp irtimer,irvalue
    jc iint02
    mov a,@r0
    orl a,irbit
    mov @r0,a
iint02:
    mov a,irbit
    clr c
    rrc a
    mov irbit,a
    jnz iint01
    mov irbit,#10000000b
    inc irptr
    jb irdetect,iint01
    mov a,@r0
    call sendchar
iint01: 
    pop acc
    pop psw
    reti

uart:
    jnb ri,euart
    push psw
    push acc
    mov tmrcom,#tmrcommax 
    mov a,#rdata
    add a,rptr
    mov r0,a
    mov @r0,sbuf
    cmp rptr,#rbcnt
    jz muart 
    inc rptr

    cmp rptr,#cmdlength
    jc muart
    setb COMavail
    clr ex0
muart:
    clr ri
    pop acc
    pop psw
euart:
    reti

IInt1:
    clr Led22
    jnb enable22,iint10
    reti
iint10:
    jb analyse,iint11
    reti
iint11:
    jnb PosChanged,iint12
    reti
iint12:
    push psw
    push acc
    clr TR0
    mov DSQTIME,TH0
    mov TL0,#xtl0
    mov TH0,#xth0
    setb TR0

    jb dsqsilence,DiseqLS

    mov a,DSQTIME
    clr c
    subb a,#xth0
    jz DiseqEnd

    inc DSQCNT
    mov a,#9
    clr c
    subb a,DSQCNT
    jnz DiseqC
;DiseqCont:
    mov DSQBIT,#10000000b
    mov DSQCNT,#0
    inc DSQBUF
    jmp DiseqEnd    ; skip parity
DiseqC:
    mov a,#6+xth0
    clr c
    subb a,DSQTIME
    jnc DiseqNext

    mov a,#DSQBUF
    add a,DSQBUF
    mov r0,a
    mov a,@r0
    orl a,DSQBIT
    mov @r0,a
DiseqNext:
    mov a,DSQBIT
    clr c
    rrc a
    mov DSQBIT,a
    jmp DiseqEnd
DiseqLS:
    clr dsqsilence
    call DSQReceived
DiseqEnd:
    pop acc
    pop psw
    reti


Start:
    using 0
    clr dsqout
    setb dsqsilence
    setb irsilence
    call irclear
    clr irdetect
    clr IRnumber
    setb analyse
    mov irdlen,#4
    mov irrecv,#255
    mov irdrep,#0
    mov irvalue,#9
    clr PosChanged
    mov motpos,#0   
    clr Enable22
    clr COMavail

    mov TL0,#xtl0   
    mov TH0,#xth0
    mov xtimer,#0
    mov rptr,#0
    mov pcon,#10010000b
    mov tmod,#00100001b
    mov th1,#0FAh
    mov tcon,#01010101b
    mov scon,#01010000b
    mov ie,#ieenable

    mov DSQBUF,#15
    call ClearDSQBuffer        

    
    mov a,#110
shownext:
    clr c
    subb a,#11
    mov chars,a
    call ShowDisplay
    call delay250ms
    jz showcont
    jmp shownext
showcont:

    mov a,#0A0h
    call i2cinit
    call ReadEpromData
    mov a,i2cerr
    jnz strcont
    call VerPosInterval
    call ShowDisplay
strcont:

    setb DSQPower
    setb still22
    jmp loop

Loop:

    jb still22,loop1
    setb Enable22
    call Transmit22w
    jb COMavail,loop1
    jmp Loop
loop1:
    clr Enable22
    call CheckUART

    jb BTNUp,loop2
    call ButtonUp
loop2:
    jb BTNDwn,loop3
    call ButtonDown
loop3:
    jnb PosChanged,loop4
    mov a,tmrpos
    jnz loop4
    mov ie,#iedisable
    call StartRotation
    call ChangePositioner
    call StopRotation
    mov ie,#ieenable
loop4:
    jmp Loop


VerPosInterval:
    cmp motpos,#maxmotpos
    jc vpi0
    mov motpos,#0
    mov chars,motpos
vpi0:
    ret

ButtonUp:
    cmp motpos,#maxmotpos-1
    jnc ButtonUp1
    inc motpos
    call SetPosChangedW
    ret
ButtonUp1:
    mov motpos,#0
    call SetPosChangedW
    ret

ButtonDown:
    mov a,motpos
    jz ButtonDown1
    dec motpos
    call SetPosChangedW
    ret
ButtonDown1:
    mov motpos,#maxmotpos-1
    call SetPosChangedW
    ret

SetPosChanged:
    mov chars,motpos
    call ShowDisplay
    mov tmrpos,#tmrposmax
    call Delay250ms            ;remote delay
    setb PosChanged
    ret

SetPosChangedW:
    call SetPosChanged
    call Delay250ms
    ret

IRReceived:
    push b
    mov a,irptr
    jnz irr10
    jmp IRRepeat
irr10:
    mov v3,#12      ;0-9+up,down
    mov i2cadrhi,#2
irr1:           
    mov a,#irdata
    mov r0,a
    mov v4,irdlen
    mov b,#8
    mov a,v3
    dec a
    mul ab
    mov i2cadrlo,a
irr3:
    call i2cEpromreadbyte 
    clr c
    subb a,@r0
    jnz irr2
    inc r0
    inc i2cadrlo
    djnz v4,irr3
    dec v3
    cmp v3,#12
    jnz irr4

irr4:
    cmp v3,#irbdown
    jnz irr5
    mov irrecv,#irbdown
    call buttondown
    jmp irr0
irr5:
    cmp v3,#irbup
    jnz irr6
    mov irrecv,#irbup
    call buttonup
    jmp irr0
irr6:
    cmp irrecv,#255
    jz irr7
    mov a,irrecv
    mov b,#10
    mul ab
    jc irr7
    clr c
    add a,v3
    mov b,a
    clr c
    subb a,#maxmotpos
    jnc irr7
    mov motpos,b
    mov irrecv,b
    call setposchanged
    jmp irr0
irr7:
    mov irrecv,v3
    mov motpos,v3
    call setposchanged
    jmp irr0
irr2:
    djnz v3,irr1
irr0:
    call irclear
    pop b
    ret

IRRepeat:
    cmp irdata,irdrep
    jnz irr0 
    cmp irrecv,#irbdown
    jnz irr20
    jmp irr4
irr20:
    cmp irrecv,#irbup
    jnz irr0
    jmp irr4


IRClear:
    mov irbit,#10000000b
    mov irptr,#0
    mov a,#irdata
    mov r0,a
    mov b,#irdatacnt
irclear0:
    mov a,#0
    mov @r0,a
    inc r0
    djnz b,irclear0
    ret

Delay250ms:
    push b
    mov b,#250
Delay250:
    call Delay1ms
    djnz b,Delay250
    pop b
    ret

ShowDisplay:
    push b
    clr DispClock
    setb DispReset
    nop
    nop
    clr DispReset
    mov a,chars
    jz ShowDisplay1
    mov b,a
ShowDisplay0:
    setb DispClock
    nop
    nop
    clr DispClock
    djnz b,ShowDisplay0
ShowDisplay1:
    pop b
    ret

TransmitDSQPower:
    jnb PosMotorOn,tdsqp3
    call Delay250ms
    call BadP1state
tdsqp3:
    clr powerstat
    jnb DSQPower,tdsqp0
    setb powerstat
tdsqp0:
    call EnableDSQPower
    call TransmitDSQ
    call Delay250ms
    jb powerstat,tdsqp
    ret
tdsqp:
    mov ptimer,#6         ; wait 6s for PosMotorOn = 1
tdsqpw:
    call Delay1s
    dec ptimer
    mov a,ptimer
    jz tdsqpw1              ; timeout
    jnb PosMotorOn,tdsqpw ; wait while PosMotorOn = 0
    call SendP1State
tdsqpw1:
    jb PosMotorOn,tdsqpw2
    call P1NotRising
tdsqpw2:
    mov ptimer,#ptimeout
tdsqp1:
    call Delay1s
    dec ptimer
    mov a,ptimer
    jz tdsqp2
    jb PosMotorOn,tdsqp1   ; wait while PosMotorOn = 1
tdsqp2:
    call EnableSTBPower
    mov a,ptimer
    jnz tdspq3
    call TimeoutRotation
    call Delay250ms
tdspq3:
    ret

ChangePositioner:
    mov chars,#90
    call ShowDisplay

    mov irrecv,#255
    clr PosChanged
;    call ShowDisplay
    call writeepromposition
    mov i2cadrhi,#1        
    mov i2cadrlo,motpos
    call i2cEpromreadbyte 
    mov a,i2cerr
    jnz chp0
    mov a,i2cbyte
    jz chp1

    mov rdata+1,#4
    mov rdata+2,#0E0h
    mov rdata+3,#031h
    mov rdata+4,#06Bh
    mov rdata+5,a
    call TransmitDSQPower
    mov chars,motpos
    call ShowDisplay
    ret
chp1:
    mov rdata+1,#4
    mov rdata+2,#0E0h
    mov rdata+3,#031h
    mov rdata+4,#06Eh
    mov rdata+5,#0
    call TransmitDSQPower
    mov chars,motpos
    call ShowDisplay
    ret
chp0:
    mov chars,#98
    call ShowDisplay
    ret

EnableDSQPower:
    clr DSQPower
    call Delay1s
    ret

EnableSTBPower:
    setb DSQPower
    call Delay250ms
    ret

ChangePowerIO:
    mov a,rdata+1
    jz cpio0
    setb DSQPower
    ret
cpio0:
    clr DSQPower
    ret

SendDSQResetAll:
    mov rdata+1,#3
    mov rdata+2,#0E0h
    mov rdata+3,#0
    mov rdata+4,#0
    call TransmitDSQ
    ret

SendDSQPowerON:
    mov rdata+1,#3
    mov rdata+2,#0E0h
    mov rdata+3,#0
    mov rdata+4,#3
    call TransmitDSQ
    ret

DSQReceived:
    mov a,dsqbuf
    dec a
    jz DSQRecClear
    call SendDSQ

;    jmp dsqrecclear

    mov a,DSQBUF+2                
    clr c
    subb a,#31h              ; is a positioner command?
    jnz DSQRecClear                
    mov a,DSQBUF+3
    clr c
    subb a,#6Bh
    jnz DSQRecClear
    mov a,DSQBUF+4

    mov motpos,a
    mov chars,motpos
    call ShowDisplay
    call writeepromposition

DSQRecClear:
;    call ClearDSQBuffer        
;    ret

ClearDSQBuffer:
    mov a,#DSQBUF
    add a,DSQBUF
    mov r0,a
cb2:
    mov a,#0
    mov @r0,a
    dec r0
    djnz DSQBUF,cb2
    mov DSQBIT,#10000000b
    mov DSQCNT,#0
    mov DSQBUF,#1
    ret

SendDSQ:
    mov a,dsqbuf
    dec a
    mov b,a
    jnz SendDSQ0
    ret
SendDSQ0:
    mov a,dsqcnt
    jz SendDSQ00
    inc b
SendDSQ00:
    mov a,#dsqbuf
    mov r1,a
SendDSQ1:
    inc r1
    mov a,@r1
    call sendchar
    djnz b,SendDSQ1
    ret

Transmit22w:
    setb DSQOut
    call Delay22H
    clr DSQOut
    call Delay22L
    ret

Transmit22wt:
    setb DSQOut
    call Delay22Ht
    clr DSQOut
    call Delay22Lt
    ret

Transmit22w0:
    mov b,#22
Trans22w00:
    call Transmit22wt
    djnz b,Trans22w00
    call Delay05ms
    ret

Transmit22w1:
    mov b,#11
Trans22w10:
    call Transmit22wt
    djnz b,Trans22w10
    call Delay05ms
    call Delay05ms
    ret

TransmitBit:
    jc TransmitBit1
    call Transmit22w0
    ret
TransmitBit1:
    call Transmit22w1
    ret

TransmitByte:
    push acc
    mov v1,#8
TransmitByte0:
    rlc a
    call TransmitBit
    djnz v1,TransmitByte0
    pop acc
    mov c,p
    cpl c
    call TransmitBit
    ret

TransmitTB:
    clr DSQOut
    call Delay15ms
    setb Enable22
    mov a,rdata+1
    jnz TransmitTB0
    mov v2,#138
ttb1:
    call Transmit22wt
    djnz v2,ttb1
    mov v2,#137
ttb2:
    call Transmit22wt
    djnz v2,ttb2
    jmp TransmitTB1
TransmitTB0:
    mov v2,#9
ttb3:
    call Transmit22w1
    djnz v2,ttb3
TransmitTB1:
    clr DSQOut
    call Delay15ms
    clr Enable22
    ret

TransmitDSQ:
    clr DSQOut
    call Delay15ms
    mov r1,#rdata+2
    mov a,rdata+1
    mov v2,a
    jnz TransmitDSQx1
    ret
TransmitDSQx1:
    setb Enable22
    mov a,@r1
    call TransmitByte
    inc r1
    djnz v2,TransmitDSQx1
    clr DSQOut
    call Delay15ms
    clr Enable22
    ret

Delay22H:
   push b
   mov b,#15
   djnz b,$
   pop b
   nop
   ret

Delay22L:
   push b
   mov b,#5
   djnz b,$
   pop b
   nop
   ret

Delay22Ht:
   push b
   mov b,#14
   djnz b,$
   pop b
   nop
   nop       
   ret

Delay22Lt:
   push b
   mov b,#12
   djnz b,$
   pop b
   nop
   ret

Delay05ms:
    push b
    mov b,#250
    djnz b,$
    mov b,#203
    djnz b,$
    nop
    pop b
    ret

Delay1ms:
    push b
    mov b,#250
    djnz b,$
    mov b,#250
    djnz b,$
    mov b,#250
    djnz b,$
    mov b,#161
    djnz b,$
    nop
    pop b
    ret

Delay15ms:
    push b
    mov b,#15
Delay15msa:
    call delay1ms
    djnz b,Delay15msa
    pop b
    ret

Delay1s:
    call Delay250ms
    call Delay250ms
    call Delay250ms
    call Delay250ms
    ret

CheckUART:
    jb COMavail,cmd0
    mov a,rptr
    jz cmde
    mov a,tmrcom
    jnz cmde
    mov rptr,#0
cmde:    
    ret
cmd0:
    clr ren
    clr ex1
    clr ET0
    clr COMavail
    mov a,rdata
cmd1:
    cjne a,#1,cmd2
    call SendInfo
    jmp cmdx
cmd2:
    cjne a,#2,cmd3     
    mov ie,#iedisable
    call TransmitTB
    jmp cmdx
cmd3:
    cjne a,#3,cmd4     
    mov ie,#iedisable
    call TransmitDSQ
    jmp cmdx
cmd4:
    cjne a,#4,cmd5
    mov a,rdata+1
    jnz cmd40
    mov motpos,rdata+2
    call VerPosInterval
    call SetPosChanged
    jmp cmdx
cmd40:  
    mov chars,rdata+2   
    call ShowDisplay
    jmp cmdx
cmd5:
    cjne a,#5,cmd6
    mov a,rdata+1
    jnz cmd50
    call ButtonUp
    jmp cmdx
cmd50:
    call ButtonDown
    jmp cmdx
cmd6:
    cjne a,#6,cmd7 
    call SendPositionerData    
    jmp cmdx
cmd7:
    cjne a,#7,cmd8
    call writeepromdatabyte
    jmp cmdx
cmd8:
    cjne a,#8,cmd9
    call readepromdata
    jmp cmdx
cmd9:
    cjne a,#9,cmd10
    mov a,rdata+1   
    jnz cmd90
    call sendepromir
    jmp cmdx
cmd90:  
    mov a,rdata+2
    jnz cmd91
    clr irdetect
    jmp cmdx
cmd91:
    setb irdetect
    jmp cmdx
cmd10:
    cjne a,#10,cmd11
    call writeepromdatabyte8
    jmp cmdx
cmd11:
    cjne a,#11,cmd12
    call ChangePowerIO
    call SendDSQPower
    jmp cmdx
cmd12:
    cjne a,#12,cmd13
    call Test22kHz
    jmp cmdx
cmd13:
    cjne a,#13,cmd14
    clr analyse
    mov a,rdata+1
    jz cmd130
    setb analyse
cmd130:
    call WriteEpromData
    call SendAnalyse
    jmp cmdx
cmd14:
    cjne a,#14,cmd15
    call SendCRLF
    jmp Start
cmd15:
    cjne a,#15,cmd16
    call GetVariables
    jmp cmdx
cmd16:
    cjne a,#16,cmd17
    mov a,rdata+1   
    jnz cmd160
    clr SW13_18
    call SendPower
    jmp cmdx
cmd160:  
    setb SW13_18
    call SendPower
    jmp cmdx 
cmd17:
    cjne a,#17,cmd18
    call SendIRVal
    jmp cmdx
cmd18:
    cjne a,#18,cmd19
    jmp cmdx
cmd19:
cmdx:
    mov rptr,#0
    setb ren
    mov ie,#ieenable
    call SendCRLF
    ret

GetVariables:
    mov a,#0
    mov r1,a
    mov b,#50
gv1:
    mov a,@r1
    call SendChar
    inc r1
    djnz b,gv1
    ret

Test22kHz:
    mov a,rdata+1
    jz Test22kHz1
    clr still22
    ret
Test22kHz1:
    setb still22
    ret


SendChar:
    clr ti
    mov sbuf,a
    jnb ti,$
    clr ti
    ret

SendStr:
    mov a,#0
    movc a,@a+dptr
    jz ess
    call SendChar
    inc dptr
    jmp SendStr
ess:
    ret

SendInfo:
    mov dptr,#version
    call SendStr
    call Delay250ms
    call SendAnalyse
    call Delay250ms
    call SendDSQPower
    call Delay250ms
    call Send22kHz
    call Delay250ms
    call SendPower
    call Delay250ms
    call SendP1State
    call Delay250ms
    ret

SendCRLF:
    mov dptr,#crlf
    call SendStr
    ret

SendONStr:
    mov dptr,#onstr
    call SendStr
    ret

SendOFFStr:
    mov dptr,#offstr
    call SendStr
    ret

SendAnalyse:
    mov dptr,#anlstr
    call SendStr
    jb analyse,sa0
    call SendOFFStr
    ret
sa0:
    call SendONStr
    ret

SendDSQPower:
    mov dptr,#pdsqstr
    call SendStr
    jnb DSQPower,sdp0
    call SendOFFStr
    ret
sdp0:
    call SendONStr
    ret

Send22Khz:
    mov dptr,#str22kHz
    call SendStr
    jnb led22,s220
    call SendOFFStr
    ret
s220:
    call SendONStr
    ret

SendPower:
    mov dptr,#powerstr
    call SendStr
    jnb SW13_18,sp0
    call Send18V
    ret
sp0:
    call Send13V
    ret

Send13V:
    mov dptr,#str13V
    call SendStr
    ret

Send18V:
    mov dptr,#str18V
    call SendStr
    ret

SendP1state:
    mov dptr,#state1
    call SendStr
    mov a,#'0'
    jnb PosMotorOn,sps0
    mov a,#'1'
sps0:
    call SendChar
    ret

BadP1state:
    mov dptr,#badstate
    call SendStr
    mov a,#'0'
    jnb PosMotorOn,bp1s
    mov a,#'1'
bp1s:
    call SendChar
    ret

P1NotRising:
    mov dptr,#notrising
    call SendStr
    mov a,#'0'
    jnb PosMotorOn,p1nr1
    mov a,#'1'
p1nr1:
    call SendChar
    ret

StartRotation:
    mov dptr,#startrot
    call SendStr
    ret

StopRotation:
    mov dptr,#stoprot
    call SendStr
    ret

TimeoutRotation:
    mov dptr,#tmostr
    call SendStr
    ret
    
SendIRVal:
    mov dptr,#irval
    call SendStr
    mov a,irvalue
    call SendASCII
    mov dptr,#irlen
    call SendStr
    mov a,irdlen
    call SendNumber
    ret

SendASCII:         ; 48='0'
    mov b,#100
    div ab
    jz sascii10
    call SendNumber
sascii10:
    mov a,b
    mov b,#10
    div ab
    jz sascii1
    call SendNumber
sascii1:
    mov a,b
    call SendNumber
    ret

SendNumber:
    add a,#48
    call SendChar
    ret

version:  db 'DiseqC Positioner V1.0',0
crlf:     db 13,10,0
state1:   db 'Antenna current (Pin1) ',0
badstate: db 'Value is bad (Pin1) ',0
notrising:db 'Not rising (Pin1) ',0
startrot: db 'Rotation start',0
stoprot:  db 'Rotation stop',0
tmostr:   db 'Rotation timeout',0
anlstr:   db 'Analyse ',0
pdsqstr:  db 'DSQ Power ',0
onstr:    db 'ON',0
offstr:   db 'OFF',0
str22kHz: db 'Signal 22kHz ',0
str13V:   db '13V',0
str18V:   db '18V',0
powerstr: db 'Antenna power ',0
irval:    db 'IR value ',0
irlen:    db ', length ',0

$include(i2c.inc)

SendPositionerData:
    mov a,motpos
    call SendChar
    mov i2cadrhi,#1
    mov i2cadrlo,#0
    mov b,#maxmotpos
spd0:
    push b
    call i2cEpromreadbyte 
    pop b
    mov a,i2cerr
    jnz epromerror
    mov a,i2cbyte
    call SendChar
    inc i2cadrlo
    djnz b,spd0
    ret 

SendEpromIR:
    mov a,irdrep
    call sendchar
    mov i2cadrhi,#2
    mov i2cadrlo,#0
    mov b,#(12*irdatacnt)
reir0:
    push b
    call i2cEpromreadbyte 
    pop b
    mov a,i2cerr
    jnz epromerror
    mov a,i2cbyte
    call sendchar
    inc i2cadrlo
    djnz b,reir0
    ret 


WriteEpromDelay:
    call delay1ms
    call delay1ms
    call delay1ms
    ret

ReadEpromData:
    mov i2cadrhi,#0
    mov i2cadrlo,#0
    call ReadEpromByte 
    mov motpos,i2cbyte
    mov chars,motpos
    call ReadEpromByte 
    mov irvalue,i2cbyte
    call ReadEpromByte 
    mov irdrep,i2cbyte
    call ReadEpromByte 
    clr analyse
    mov a,i2cbyte
    jz red1
    setb analyse
red1:
;    call ReadEpromByte 
;    mov irdlen,i2cbyte
    ret 

ReadEpromByte:
    call i2cEpromreadbyte 
    mov a,i2cerr
    jnz epromerror
    inc i2cadrlo
    ret

epromerror:
    mov chars,#99
    call ShowDisplay
    ret

WriteEpromDataByte:
    mov i2cadrhi,rdata+1
    mov i2cadrlo,rdata+2
    mov i2cbyte,rdata+3
    call WriteDataByte
    ret 

WriteDataByte:
    call i2cEpromwritebyte 
    mov a,i2cerr
    call SendChar
    mov a,i2cerr
    jnz epromerror
    call writeepromdelay
    inc i2cadrlo
    ret

WriteDataByteX:
    call i2cEpromwritebyte 
    mov a,i2cerr
    jnz epromerror
    call writeepromdelay
    inc i2cadrlo
    ret


WriteEpromDataByte8:
    mov i2cadrhi,rdata+1
    mov i2cadrlo,rdata+2
    mov i2cbyte,rdata+3
    call WriteDataByte
    mov i2cbyte,rdata+4
    call WriteDataByte
    mov i2cbyte,rdata+5
    call WriteDataByte
    mov i2cbyte,rdata+6
    call WriteDataByte
    mov i2cbyte,rdata+7
    call WriteDataByte
    mov i2cbyte,rdata+8
    call WriteDataByte
    mov i2cbyte,rdata+9
    call WriteDataByte
    mov i2cbyte,rdata+10
    call WriteDataByte
    ret 

WriteEpromPosition:
    mov i2cadrhi,#0
    mov i2cadrlo,#0
    mov i2cbyte,motpos
    call WriteDataByteX
    ret 

WriteEpromData:
    mov i2cadrhi,#0
    mov i2cadrlo,#0
    mov i2cbyte,motpos
    call WriteDataByteX
    mov i2cbyte,irvalue
    call WriteDataByteX
    mov i2cbyte,irdrep
    call WriteDataByteX
    mov i2cbyte,#0
    jnb analyse,wed1
    mov i2cbyte,#1
wed1:
    call WriteDataByteX
;    mov i2cbyte,irdlen
;    call WriteDataByteX
    ret


end
