;$mod51
;sda bit p0.0
;scl bit p0.1

dseg

i2cdev: ds 1
i2cadrhi: ds 1
i2cadrlo: ds 1
i2cbyte: ds 1
i2cerr: ds 1

cseg

i2cdelay:
    push b
    mov b,#8
    djnz b,$
    pop b
    ret

i2cdelay2:
    push b
    mov b,#4
    djnz b,$
    pop b
    ret

i2cinit:
    setb sda
    setb scl
    mov i2cdev,a
    mov i2cadrhi,#0
    mov i2cadrlo,#0
    mov i2cerr,#0
    ret

i2cstart:
    setb scl
    call i2cdelay2 
    setb sda
    call i2cdelay
    clr sda          
    call i2cdelay
    ret

i2crestart:          
    clr scl
    call i2cdelay
    clr sda
    call i2cdelay
    setb sda
    call i2cdelay
    setb scl
    call i2cdelay
    clr sda          
    call i2cdelay
    ret

i2cstop:
    clr scl
    call i2cdelay   
    clr sda
    call i2cdelay
    setb scl
    call i2cdelay
    setb sda
    call i2cdelay
    ret

i2csendack:
    clr scl
    call i2cdelay2
    clr sda
    call i2cdelay2
    setb scl
    call i2cdelay
    ret

i2cgetack:
    clr scl
    call i2cdelay2
    setb sda
    call i2cdelay2
    setb scl
    call i2cdelay
    mov c,sda
    cpl c
    ret

i2csendbyte:
    mov b,#8
i2csendbyte1:
    clr scl
    call i2cdelay2
    rlc a
    mov sda,c
    call i2cdelay2
    setb scl
    call i2cdelay
    djnz b,i2csendbyte1
    call i2cgetack
    ret

i2creceiveackbyte:
    setb sda
    mov b,#8
    mov a,#0
i2creceivebyte1:
    clr scl
    call i2cdelay
    setb scl
    call i2cdelay
    mov c,sda
    rlc a
    djnz b,i2creceivebyte1
    call i2csendack
    ret

i2creceivenoackbyte:
    setb sda
    mov b,#8
    mov a,#0
i2creceivebyte11:
    clr scl
    call i2cdelay
    setb scl
    call i2cdelay
    mov c,sda
    rlc a
    djnz b,i2creceivebyte11
; noack
    clr scl
    call i2cdelay
    setb scl
    call i2cdelay
    ret

i2cEpromWriteByte:
    mov i2cerr,#0
    call i2cstart
    call i2cEpromsetaddr
    call i2csendbyte
    jnc i2cEpromwritebytenoack
    mov a,i2cadrlo
    call i2csendbyte
    jnc i2cEpromwritebytenoack
    mov a,i2cbyte
    call i2csendbyte
    jnc i2cEpromwritebytenoack
    call i2cstop
    ret
i2cEpromwritebytenoack:
    mov i2cerr,#1
    call i2cstop
    ret 

i2cEpromsetaddr:
    mov a,i2cadrhi
    clr c
    rlc a
    anl a,#00001110b
    orl a,i2cdev   
;call sendchar
    ret

i2cEpromreadbyte:
    mov i2cerr,#0
    call i2cstart
    call i2cEpromsetaddr
    call i2csendbyte
    jnc i2cEpromreadbytenoack
    mov a,i2cadrlo
    call i2csendbyte
    jnc i2cEpromreadbytenoack

    call i2crestart
    mov a,i2cdev
    orl a,#1
    call i2csendbyte
    jnc i2cEpromreadbytenoack
    call i2creceivenoackbyte
    mov i2cbyte,a
    call i2cstop
    ret
i2cEpromreadbytenoack:
    mov i2cerr,#1
    call i2cstop
    ret 
    
;end    
