unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, inifiles, ExtCtrls, unitx;

type

  tdescarray = record
   vr: byte;
   db: byte;
   desc: string;
  end;

const

  framinglen = 7;
  tframingbyte : array [0..framinglen] of tdescarray =
  ((db:$E0;desc:'Master First (NoReply)'),
   (db:$E1;desc:'Master Repeat (NoReply)'),
   (db:$E2;desc:'Master First (ReqReply)'),
   (db:$E3;desc:'Master Repeat (ReqReply)'),
   (db:$E4;desc:'Slave Reply (OK)'),
   (db:$E5;desc:'Slave Reply (Cmd Supported)'),
   (db:$E6;desc:'Slave Reply (Parity Error)'),
   (db:$E7;desc:'Slave Reply (Cmd not recognized)'));

   familylen = 17;
   tfamilybyte: array [0..familylen] of tdescarray =
   ((db:$00;desc:'Any device (Master to all)'),
    (db:$10;desc:'Any LNB, Switcher or SMATV (Master to all)'),
    (db:$11;desc:'LNB'),
    (db:$12;desc:'LNB with Loop-through switching'),
    (db:$14;desc:'Switcher (d.c. blocking)'),
    (db:$15;desc:'Switcher with d.c. Loop-through'),
    (db:$18;desc:'SMATV'),
    (db:$20;desc:'Any Polariser (Master to all Polarisers)'),
    (db:$21;desc:'Linear Polarisation (Skew) Controller'),
    (db:$30;desc:'Any Positioner (Master to all Positioners)'),
    (db:$31;desc:'Polar/Azimuth Positioner'),
    (db:$32;desc:'Elevation Positioner'),
    (db:$40;desc:'Any Installer Aid (Master to all Installer Aids)'),
    (db:$41;desc:'Signal-strenght analogue value'),
    (db:$60;desc:'Family reserved for address re-allocation'),        // $6x
    (db:$70;desc:'Any Intelligent Slave Interfaces (Master to all)'),
    (db:$71;desc:'Interface for subscriber controlled headends'),
    (db:$F0;desc:'Reserved for OEM Extensions'));                    // $Fx

   complen = 3;
   tcompat: array [0..complen] of tdescarray =
   ((vr:10;db:0;desc:'V 1.0'),
    (vr:11;db:0;desc:'V 1.1'),
    (vr:12;db:0;desc:'V 1.2'),
    (vr:20;db:0;desc:'V 2.0'));

   cmdlen = 64;
   tcmdbyte: array [0..cmdlen] of tdescarray =
   ((vr:10;db:$00;desc:'Reset DISEqC microcontroller'), // reset
    (vr:20;db:$01;desc:'Clear "Reset" flag'),           // Clr Reset
    (vr:10;db:$02;desc:'Switch peripheral power supply off'),
    (vr:10;db:$03;desc:'Switch peripheral power supply on'),
    (vr:20;db:$04;desc:'Set contention flag'),
    (vr:20;db:$05;desc:'Return address only if Contention flag is set'),
    (vr:20;db:$06;desc:'Clear contention flag'),
    (vr:20;db:$07;desc:'Return address unless Contention flag is set'),
    (vr:20;db:$08;desc:'Change address only if Contention flag is set'),
    (vr:20;db:$09;desc:'Change address unless Contention flag is set'),
    (vr: 0;db:$0F;desc:'Reserved'),
    (vr:20;db:$10;desc:'Read Status register flag'),
    (vr:20;db:$11;desc:'Read Configuration flags (peripheral hardware)'),
    (vr:20;db:$14;desc:'Read Switching state flags (Committed port)'),
    (vr:20;db:$15;desc:'Read Switching state flags (Uncommitted port)'),
    (vr:20;db:$16;desc:'expansion option'),
    (vr:20;db:$17;desc:'expansion option'),
    (vr:10;db:$20;desc:'Select the Low Local Oscillator frequency'),
    (vr:10;db:$21;desc:'Select Vertical Polarisation (or Right circular)'),
    (vr:10;db:$22;desc:'Select Satellite position A (or position C)'),
    (vr:10;db:$23;desc:'Select Switch Option A (e.g. position A/B)'),
    (vr:10;db:$24;desc:'Select the High Local Oscillator frequency'),
    (vr:10;db:$25;desc:'Select Horizontal Polarisation (or Left circular)'),
    (vr:10;db:$26;desc:'Select Satellite position B (or position D)'),
    (vr:10;db:$27;desc:'Select Switch Option B (e.g. position C/D)'),
    (vr:11;db:$28;desc:'Select Switch S1 input A (deselect input B)'),
    (vr:11;db:$29;desc:'Select Switch S2 input A (deselect input B)'),
    (vr:11;db:$2A;desc:'Select Switch S3 input A (deselect input B)'),
    (vr:11;db:$2B;desc:'Select Switch S4 input A (deselect input B)'),
    (vr:11;db:$2C;desc:'Select Switch S1 input B (deselect input A)'),
    (vr:11;db:$2D;desc:'Select Switch S2 input B (deselect input A)'),
    (vr:11;db:$2E;desc:'Select Switch S3 input B (deselect input A)'),
    (vr:11;db:$2F;desc:'Select Switch S4 input B (deselect input A)'),
    (vr:11;db:$30;desc:'Ignore all bus command except "Awake"'),
    (vr:11;db:$31;desc:'Respond to future bus commands normaly'),
    (vr:10;db:$38;desc:'Write to Port group 0 (Committed switches)'),
    (vr:11;db:$39;desc:'Write to Port group 1 (Uncommitted switches)'),
    (vr:11;db:$3A;desc:'expansion option'),
    (vr:11;db:$3B;desc:'expansion option'),
    (vr:20;db:$40;desc:'Read Analogue value A0'),
    (vr:20;db:$41;desc:'Read Analogue value A1'),
    (vr:12;db:$48;desc:'Write Analogue value A0 (e.g. Skew)'),
    (vr:12;db:$49;desc:'Write Analogue value A1'),
    (vr:20;db:$50;desc:'Read current frequency (Reply=BCD string)'),
    (vr:20;db:$51;desc:'Read current frequency table entry number'),
    (vr:20;db:$52;desc:'Read Lo frequency table entry number'),
    (vr:20;db:$53;desc:'Read Hi frequency table entry number'),
    (vr:11;db:$58;desc:'Write channel frequency (BCD string)'),
    (vr:11;db:$59;desc:'Write (receiver''s) selected channel number'),
    (vr:12;db:$60;desc:'Stop Positioner movement'),
    (vr: 0;db:$61;desc:'Reserved'),
    (vr: 0;db:$62;desc:'Reserved'),
    (vr:12;db:$63;desc:'Disable Limits'),
    (vr:22;db:$64;desc:'Read Positioner Status Register'),
    (vr: 0;db:$65;desc:'Reserved'),
    (vr:12;db:$66;desc:'Set East Limit (&Enable recommended)'),
    (vr:12;db:$67;desc:'Set West Limit (&Enable recommended)'),
    (vr:12;db:$68;desc:'Drive Motor East (with optional timeout/steps)'),
    (vr:12;db:$69;desc:'Drive Motor West (with optional timeout/steps)'),
    (vr:12;db:$6A;desc:'Store Satellite Position & Enable Limits'),
    (vr:12;db:$6B;desc:'Drive Motor to Satellite Position nn'),
    (vr: 0;db:$6C;desc:'Reserved'),
    (vr: 0;db:$6D;desc:'Reserved'),
    (vr:12;db:$6E;desc:'Drive Motor to Angular Position ()'),
    (vr:12;db:$6F;desc:'(Re-)Calculate Satellite Positions'));


type

  TReadThread = class(TThread)
  public
   fs: string;
   constructor Create;
   procedure Execute; override;
   procedure ShowStr;
  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    Reader1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Panel1: TPanel;
    Info1: TMenuItem;
    N2: TMenuItem;
    Send1: TMenuItem;
    Reset1: TMenuItem;
    framing: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    family: TComboBox;
    Label3: TLabel;
    command: TComboBox;
    Label4: TLabel;
    opt1: TEdit;
    opt2: TEdit;
    opt3: TEdit;
    Compatibility: TLabel;
    compat: TComboBox;
    Sendselectedcommand1: TMenuItem;
    DrivePolarMotorto01: TMenuItem;
    Log1: TMenuItem;
    Clearlog1: TMenuItem;
    Savelog1: TMenuItem;
    N3: TMenuItem;
    SwitchperipheralpowerON1: TMenuItem;
    Showtimestamp1: TMenuItem;
    RemoteControl1: TMenuItem;
    Positioner1: TMenuItem;
    StepUp1: TMenuItem;
    StepDown1: TMenuItem;
    N4: TMenuItem;
    Settings1: TMenuItem;
    Setposition1: TMenuItem;
    RecalculateSatellitePositionsE0316F001: TMenuItem;
    DriveStepMotorEastE03168FF1: TMenuItem;
    DriveStepMotorWestE03169FF1: TMenuItem;
    settings2: TMenuItem;
    N5: TMenuItem;
    IRValueDetectEnable1: TMenuItem;
    IRValueDetectDisable1: TMenuItem;
    IRValueSet1: TMenuItem;
    N6: TMenuItem;
    ShowCRLF1: TMenuItem;
    ShowBINARY1: TMenuItem;
    dsqon1: TMenuItem;
    Test22kHz1: TMenuItem;
    reset2: TMenuItem;
    ShowASCII1: TMenuItem;
    Hardware1: TMenuItem;
    ShowHEX1: TMenuItem;
    N7: TMenuItem;
    sd: TSaveDialog;
    Analyse1: TMenuItem;
    IRValueGet1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure compatChange(Sender: TObject);
    procedure DrivePolarMotorto01Click(Sender: TObject);
    procedure Sendselectedcommand1Click(Sender: TObject);
    procedure Clearlog1Click(Sender: TObject);
    procedure Savelog1Click(Sender: TObject);
    procedure SwitchperipheralpowerON1Click(Sender: TObject);
    procedure DriveStepMotorEastE03168FF1Click(Sender: TObject);
    procedure DriveStepMotorWestE03169FF1Click(Sender: TObject);
    procedure RecalculateSatellitePositionsE0316F001Click(Sender: TObject);
    procedure Showtimestamp1Click(Sender: TObject);
    procedure StepUp1Click(Sender: TObject);
    procedure StepDown1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Setposition1Click(Sender: TObject);
    procedure settings2Click(Sender: TObject);
    procedure IRValueDetectEnable1Click(Sender: TObject);
    procedure IRValueDetectDisable1Click(Sender: TObject);
    procedure IRValueSet1Click(Sender: TObject);
    procedure ShowCRLF1Click(Sender: TObject);
    procedure ShowBINARY1Click(Sender: TObject);
    procedure dsqon1Click(Sender: TObject);
    procedure Test22kHz1Click(Sender: TObject);
    procedure reset2Click(Sender: TObject);
    procedure ShowASCII1Click(Sender: TObject);
    procedure ShowHEX1Click(Sender: TObject);
    procedure Analyse1Click(Sender: TObject);
    procedure IRValueGet1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure AddStr(s:string);
   function openport: boolean;
   procedure LoadProtocol(cp,fr,fa,co,o1,o2,o3: integer);
   procedure SendCmd(cmd: string; chars: byte);
  end;

var

  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.DFM}

const rcvsize = 10000;

type rcvbuf = array [0..rcvsize] of char;
     tshowdata=(shhex,shbinary,shascii);

const  infocmd = #1;
       transTB = #2;
       transDSQ = #3;
       setmotorposition = #4;
       buttonupdown = #5;
       getpositionerdata = #6;
       writedatabyte = #7;
       reloaddata = #8;
       getirvalues = #9;
       writedatabyte8 = #10;
       diseqonoff=#11;
       test22khz=#12;
       analyseofoff=#13;
       swreset=#14;
       irvalueget=#17;

var
  comhandle: thandle= 0;
  readthread: treadthread = nil;
  nrcv: cardinal;
  rcv: rcvbuf;
  loglines: integer = -1;
  portopen: boolean = false;
  showcrlf: boolean = true;
  showdata: tshowdata = shhex;



procedure WDelay(delay: integer);
var n: tdatetime;
begin
 n := now+delay/(24*60*60*1000);
 while n > now do begin
  application.processmessages;
  sleepex(100,true);
 end;
end;


procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

constructor TReadThread.Create;
begin
 inherited Create(true);
 freeonterminate := true;
 priority := tpNormal;
 resume;
end;

procedure TReadthread.ShowStr;
begin
 if (Form1 <> nil) and (fs <> '') then Form1.addstr('R: '+ fs);
end;

procedure TReadthread.Execute;
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 repeat
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin
       if nrcv + nr > rcvsize then begin
        fs := 'Buffer full'; Synchronize(ShowStr);
        nrcv := 0;
        if nr > rcvsize then continue; // discard chars
       end;
        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;  fs := '';
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
          case showdata of
           shhex: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + inttohex(byte(r[i]),2);
           end;
           shbinary: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + binb(byte(r[i]));
           end;
           shascii: begin
            if r[i] = #13 then fs := fs + '<CR>' else
            if r[i] = #10 then fs := fs + '<LF>' else
            if r[i] in [#32..#126] then fs := fs + r[i] else
              fs := fs + '0x'+inttohex(byte(r[i]),2);
           end;
          end;
          if showdata <> shascii then fs := fs + ' ';
         end;
          Synchronize(ShowStr);
        end;
      end;
    end;
  end;
except
 on e: exception do ebox('Thread '+e.message);
end;
 until application.Terminated or terminated;
end;


function waitrcv(chars: byte): boolean;
var t: tdatetime;
    timeout: boolean;
begin
 t := now + 3/(24*3600);
 repeat
  sleepex(100,true);
  timeout := t < now;
  application.ProcessMessages;
 until (nrcv >= chars) or timeout;
 if timeout then result := false else result := true;
end;

function doopenport(var ph: thandle): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
    f: tinifile;
    c: string;
    brate: integer;
    e: integer;

begin
 result := false;
 f := tinifile.create(_exedir+_exename+'.ini');
try
 c := uppercase(f.ReadString('init','port','COM1'));
 brate := f.ReadInteger('init','baud',19200);
finally
 f.free;
end;
 ph := CreateFile(pchar(c),GENERIC_READ or GENERIC_WRITE, 0,nil,OPEN_EXISTING, 0, 0);
 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE');
  exit;
 end;
 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);
 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   e := getlasterror;
   ebox(format('ComHandle GetCommState %s',[syserrormessage(e)]));
   exit;
  end;
 dcb.BaudRate := brate;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := ONESTOPBIT;
 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '+syserrormessage(getlasterror));
   exit;
  end;
 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '+syserrormessage(getlasterror));
   exit;
  end;
 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;
 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '+syserrormessage(getlasterror));
   exit;
  end;
 result := true;
end;

function TForm1.openport: boolean;
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;
 if not doopenport(comhandle) then exit;
 if not SetCommMask(comhandle, EV_RXCHAR) then begin
  ebox('ComHandle SetCommMask '+syserrormessage(getlasterror));
 end;
 sleep(100);
 ClearCom(comhandle);
 readthread := Treadthread.Create;
 result := true;
 portopen := true;
 addstr('COM port opened');
end;


function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(syserrormessage(getlasterror));
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
var tt: string;
begin
try
 m.lines.BeginUpdate;
try
 if Showtimestamp1.Checked then
  tt := formatdatetime('dd.mm.yy hh:nn:ss ',now) else
  tt := '';
 if loglines > 0 then
 while m.lines.count > loglines do begin
  m.Lines.Delete(m.lines.count-1);
 end;
 m.lines.insert(0,tt+trimright(s));
finally
 m.lines.EndUpdate;
end;
except
 on e: exception do ebox(e.message);
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('DiSEqC Reader/Writer/Positioner'#13#13'copyright (c) Zelenka 2009');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.SendCmd(cmd: string; chars: byte);
var s,p: string;
    i: integer;
const cmdlength = 11;
begin
 if not portopen then openport;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
 addstr('S: '+p);
 if sendstring(cmd) then begin
  if waitrcv(chars) then begin
  s := copy(rcv,1,nrcv-2);
  sb1.Panels[1].text := '';
  end else begin
   addstr('Receive error!');
   beep;
  end;
 end;
 sb1.Panels[1].text := '';
end;

procedure TForm1.LoadProtocol(cp,fr,fa,co,o1,o2,o3: integer);
var i: integer;
    s: string;
begin
 DecimalSeparator := '.';
 if o1 >= 0 then opt1.Text := inttostr(o1);
 if o2 >= 0 then opt2.Text := inttostr(o2);
 if o3 >= 0 then opt3.Text := inttostr(o3);
 framing.Clear;
 for i := 0 to framinglen do begin
  framing.Items.Add(format('%.2xh %s',[tframingbyte[i].db,tframingbyte[i].desc]));
 end;
 framing.ItemIndex := fr;
 family.Clear;
 for i := 0 to familylen do begin
  family.Items.Add(format('%.2xh %s',[tfamilybyte[i].db,tfamilybyte[i].desc]));
 end;
 family.ItemIndex := fa;
 command.Clear;
 for i := 0 to cmdlen do begin
  if tcmdbyte[i].vr <= tcompat[cp].vr then begin
   if tcmdbyte[i].vr > 0 then s := format(' %2.1f',[tcmdbyte[i].vr/10]) else s := '';
   command.Items.Add(format('%.2xh%s %s',[tcmdbyte[i].db,s,tcmdbyte[i].desc]));
  end;
 end;
 if co > command.Items.Count - 1 then co := command.Items.Count - 1;
 command.ItemIndex := co;
 compat.Clear;
 for i := 0 to complen do begin
  compat.Items.Add(format('%s',[tcompat[i].desc]));
 end;
 compat.ItemIndex := cp;
end;

procedure TForm1.FormCreate(Sender: TObject);
var f: tinifile;
begin
 sd.InitialDir := _exedir;
 f := tinifile.create(_exedir+_exename+'.ini');
 loglines := f.ReadInteger('init','loglines',-1);
 f.free;
 m.Clear;
 opt1.Text := '1';
 opt2.Text := '';
 opt3.Text := '';
 LoadProtocol(2,0,10,40,-1,-1,-1);
 ShowHEX1Click(Sender);
end;

procedure TForm1.compatChange(Sender: TObject);
begin
 LoadProtocol(compat.ItemIndex,framing.ItemIndex,family.ItemIndex,
  command.ItemIndex,-1,-1,-1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
//
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 openport;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('COM port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  openport;
 end;
end;

procedure TForm1.Info1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 SendCmd(infocmd,90); // 10
 showdata := b;
end;

procedure TForm1.Reset1Click(Sender: TObject);
begin
 SendCmd(transDSQ+#3#$E0#0#0,2);
end;

procedure TForm1.SwitchperipheralpowerON1Click(Sender: TObject);
begin
 SendCmd(transDSQ+#3#$E0#0#3,2);
end;

procedure TForm1.DrivePolarMotorto01Click(Sender: TObject);
begin
 SendCmd(transDSQ+#4#$E0#$31#$6E#0,2);
end;

procedure TForm1.DriveStepMotorEastE03168FF1Click(Sender: TObject);
begin
 SendCmd(transDSQ+#4#$E0#$31#$68#$FF,2);
end;

procedure TForm1.DriveStepMotorWestE03169FF1Click(Sender: TObject);
begin
 SendCmd(transDSQ+#4#$E0#$31#$69#$FF,2);
end;

procedure TForm1.RecalculateSatellitePositionsE0316F001Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then begin
  SendCmd(transDSQ+#4#$E0#$31#$6F#0,2);
//  SendCmd(transDSQ+#6#$E0#$31#$6F#0#0#0,2);
 end;
end;

procedure TForm1.Sendselectedcommand1Click(Sender: TObject);
var s,o1,o2,o3: string;
    i,j: integer;
begin
 o1 := system.copy(command.items[command.ItemIndex],1,2);
 i := strtoint('0x'+o1);
 s := char(tframingbyte[framing.ItemIndex].db)+
      char(tfamilybyte[family.ItemIndex].db)+char(i);
 j := 3;
 o1 := trim(opt1.text); o2 := trim(opt2.text); o3 := trim(opt3.text);
 if o1 <> '' then begin i := strtoint(o1); s := s + char(i); inc(j); end;
 if o2 <> '' then begin i := strtoint(o2); s := s + char(i); inc(j); end;
 if o3 <> '' then begin i := strtoint(o3); s := s + char(i); inc(j); end;
 SendCmd(transDSQ+char(j)+s,2);
end;

procedure TForm1.Showtimestamp1Click(Sender: TObject);
begin
 Showtimestamp1.Checked := not Showtimestamp1.Checked;
end;

procedure TForm1.Clearlog1Click(Sender: TObject);
var r: word;
begin
 r := application.messagebox('Clear Log?', 'Question', MB_TOPMOST + mb_iconquestion+mb_yesno);
 if r = idyes then m.clear;
end;

procedure TForm1.Savelog1Click(Sender: TObject);
begin
 if sd.Execute then begin
  m.Lines.SaveToFile(sd.filename);
 end;
end;

procedure TForm1.ShowHEX1Click(Sender: TObject);
begin
 showhex1.Checked := true;
 showdata := shhex;
 showASCII1.Checked := false;
 showbinary1.Checked := false;
 sb1.Panels[0].Text := ' Show HEX';
end;

procedure TForm1.ShowASCII1Click(Sender: TObject);
begin
 showASCII1.Checked := true;
 showdata := shascii;
 showbinary1.Checked := false;
 showhex1.Checked := false;
 sb1.Panels[0].Text := ' Show ASCII';
end;

procedure TForm1.ShowCRLF1Click(Sender: TObject);
begin
 showcrlf1.Checked := not showcrlf1.Checked;
 showcrlf := showcrlf1.Checked;
end;

procedure TForm1.ShowBINARY1Click(Sender: TObject);
begin
 showbinary1.Checked := true;
 showdata := shbinary;
 showASCII1.Checked := false;
 showhex1.Checked := false;
 sb1.Panels[0].Text := ' Show BINARY';
end;

procedure TForm1.IRValueDetectEnable1Click(Sender: TObject);
begin
 SendCmd(getirvalues+#1#1,2);
end;

procedure TForm1.IRValueDetectDisable1Click(Sender: TObject);
begin
 SendCmd(getirvalues+#1#0,2);
end;

procedure TForm1.IRValueSet1Click(Sender: TObject);
var s: string;
    p: byte;
begin
 if not InputQuery('Enter IR Value','',s) then exit;
 p := strtoint(trim(s));
 SendCmd(writedatabyte +#0#1+char(p),3);
 SendCmd(reloaddata,2);
end;

procedure TForm1.IRValueGet1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 SendCmd(irvalueget,2);
 showdata := b;
end;

procedure TForm1.settings2Click(Sender: TObject);
var i: integer;
const datalen=maxir+3;
begin
 SendCmd(getirvalues,datalen);
 if nrcv = datalen then begin
  irdata[maxir] := byte(rcv[0]);
  for i := 1 to maxir do irdata[i-1] := byte(rcv[i]);
  form3.settings;
  if form3.ShowModal = mrok then begin
   i := 0;
   repeat
    SendCmd(writedatabyte8 +#2+chr(i)+char(irdata[i])+char(irdata[i+1])+
                                      char(irdata[i+2])+char(irdata[i+3])+
                                      char(irdata[i+4])+char(irdata[i+5])+
                                      char(irdata[i+6])+char(irdata[i+7]),10);
    inc(i,8);
   until i >= maxir;
   SendCmd(writedatabyte +#0#2+char(irdata[maxir]),3);
   SendCmd(reloaddata,2);
//    if rcv <> #0#13#10 then error
   ibox('Done');
  end;
 end else ebox('Error on receive!');
end;

procedure TForm1.StepUp1Click(Sender: TObject);
begin
 SendCmd(buttonupdown+#0,2);
end;

procedure TForm1.StepDown1Click(Sender: TObject);
begin
 SendCmd(buttonupdown+#1,2);
end;

procedure TForm1.Setposition1Click(Sender: TObject);
var s: string;
    p: byte;
begin
 if not InputQuery('Enter positioner position','',s) then exit;
 p := strtoint(trim(s));
 SendCmd(setmotorposition+#0+char(p),2);
end;

procedure TForm1.Settings1Click(Sender: TObject);
var i: integer;
const stradr=1;
      datalen=35;
begin
 SendCmd(getpositionerdata,datalen);
 if nrcv = datalen then begin
  for i := 0 to maxpos-1 do posdata[i] := byte(rcv[i+stradr]);
  form2.settings;
  if form2.ShowModal = mrok then begin
   i := 0;
   repeat
    SendCmd(writedatabyte8 +#1+chr(i)+char(posdata[i])+char(posdata[i+1])+
                                      char(posdata[i+2])+char(posdata[i+3])+
                                      char(posdata[i+4])+char(posdata[i+5])+
                                      char(posdata[i+6])+char(posdata[i+7]),10);
    inc(i,8);
   until i >= maxpos;
//    if rcv <> #0#13#10 then error
   ibox('Done');
  end;
 end else ebox('Error on receive!');
end;

procedure TForm1.dsqon1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 dsqon1.Checked := not dsqon1.Checked;
 if dsqon1.Checked then
 SendCmd(diseqonoff+#0,2) else SendCmd(diseqonoff+#1,2);
 showdata := b;
end;

procedure TForm1.Analyse1Click(Sender: TObject);
var b: tshowdata;
begin
 b := showdata;
 showdata := shascii;
 Analyse1.Checked := not Analyse1.Checked;
 if Analyse1.Checked then
 SendCmd(analyseofoff+#1,2) else SendCmd(analyseofoff+#0,2);
 showdata := b;
end;

procedure TForm1.Test22kHz1Click(Sender: TObject);
begin
 test22khz1.Checked := not test22khz1.Checked;
 if test22khz1.Checked then
 SendCmd(test22khz+#1,2) else  SendCmd(test22khz+#0,2);
end;

procedure TForm1.reset2Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then begin
  SendCmd(swreset,2);
  dsqon1.Checked := false;
  test22khz1.Checked := false;
 end;
end;






end.
